package de.interpreter.brainfuck;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.text.InputType;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;

/**
 * 
 * @author Daniel lschlegel
 * @license 2-BSDL
 * 2012/03
 *
 */

public class BrainfuckActivity extends Activity implements OnClickListener{
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        // disable soft keyboard
        //((EditText) findViewById(R.id.outputfield)).setInputType(InputType.TYPE_NULL);
        
        // register all button onclickhandler 
        for(int i = 1; i <= 11; ++i) {
        	int resID = this.getResources().getIdentifier("button"+i, "id", "de.interpreter.brainfuck");
            ((Button)findViewById(resID)).setOnClickListener(this);
        }
    }
    
    public void onClick(View arg0) {
		String caption = ((Button) arg0).getText().toString();
		EditText inputField = (EditText) findViewById(R.id.inputfield);
		EditText outputField = (EditText) findViewById(R.id.outputfield);
		
		char buttonChar = caption.charAt(0);
		switch(buttonChar) {
		// special commands ignore non english locales
		case '<': case '>': case '+': case '-': 
		case '.': case ',':	case '[': case ']':
			String text = inputField.getText().toString();
			int start =  inputField.getSelectionStart();
			inputField.setText(text.substring(0, start) + buttonChar + text.substring(start));
			inputField.setSelection(start + 1);
			break;
		case 'D': 
			inputField.setText(""); 
			break;
		case 'r': 
			outputField.append(new BfInterpreter(inputField.getText().toString(), this).run(0));
			break;
		case 'c': 
			outputField.setText(""); 
			break;
		default:
			break;
		}
    }

}